<template>
    <div class="app-container">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
        <el-form-item label="名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
       
        <el-form-item label="类型" prop="type">
          <!-- <el-input
            v-model="queryParams.orderNum"
            placeholder="请输入排序"
            clearable
            @keyup.enter.native="handleQuery"
          />-->
          <el-select v-model="queryParams.type" placeholder=""> 
                <el-option label="派出所民警" :value="3"></el-option>
                <el-option label="消防大队" :value="4"></el-option>
                <el-option label="消防监督工作站" :value="5"></el-option>
                <el-option label="安全员" :value="6"></el-option>
            </el-select>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
  
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['gaoqu:psap:add']"
          >新增</el-button>
        </el-col>
        <!-- <el-col :span="1.5">
          <el-button
            type="success"
            plain
            icon="el-icon-edit"
            size="mini"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['gaoqu:psap:edit']"
          >修改</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['gaoqu:psap:remove']"
          >删除</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['gaoqu:psap:export']"
          >导出</el-button> -->
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
  
      <el-table v-loading="loading" :data="psapList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <!-- <el-table-column label="" align="center" prop="id" /> -->
        <el-table-column label="名称" align="center" prop="name" />
        <!-- <el-table-column label="排序" align="center" prop="orderNum" /> -->
         <el-table-column label="类型" align="center" prop="typeName" />
         <!--  <el-table-column label="所属部门" align="center" prop="deptNames" >
            <template slot-scope="scope">
              {{ scope.row.deptNames.length && scope.row.deptNames.join(',')|| '-' }}
            </template>
           </el-table-column> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['gaoqu:psap:edit']"
            >修改</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['gaoqu:psap:remove']"
            >删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
  
      <!-- 添加或修改公安武警对话框 -->
      <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body
      :close-on-click-modal="false">
        <el-form ref="form" :model="form" :rules="rules" label-width="80px">
          <el-form-item label="名称" prop="name">
            <el-input v-model="form.name" placeholder="请输入名称" />
          </el-form-item>
          <el-form-item label="类型" prop="orderNum">
            <el-select v-model="form.type" placeholder=""> 
                <el-option label="派出所民警" :value="3"></el-option>
                <el-option label="消防大队" :value="4"></el-option>
                <el-option label="消防监督工作站" :value="5"></el-option>
                <el-option label="安全员" :value="6"></el-option>
            </el-select>
          </el-form-item>
          <!-- <el-form-item label="管辖网格" prop="orderNum">
            <el-select 
              v-model="form.deptIds"
               placeholder="" multiple
               filterable
               :filter-method="filterDept" 
               
               >
                <el-option v-for="item in filteredCities" :key="item.deptId" :label="item.deptName" :value="item.deptId">
                </el-option>
            </el-select>
          </el-form-item> -->
          <el-form-item label="管辖网格" prop="orderNum">
            <treeselect
								v-model="form.deptIds"
								:options="deptOptions"
								:multiple="true"
								placeholder="请选择隶属网格"
							/>
          </el-form-item>

        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </el-dialog>
    </div>
  </template>
  
  <script>
import {
  listPsap,
  getPsap,
  delPsap,
  addPsap,
  updatePsap,
  getAllDept,
} from "@/api/gaoqu/gonganwujing";

import {
	deptList,
} from "@/api/stData/merchantList";

import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";



export default {
  name: "Psap",
  components: { Treeselect },
  data() {
    return {

      deptOptions: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 公安武警表格数据
      psapList: [],
      options4dept: [],
      filteredCities:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        orderNum: null,
        type: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getList();
    this.getDeptTree();
    getAllDept().then((response) => {
      this.options4dept = response.data;
      this.filteredCities = response.data
    });
  },
  methods: {
    /** 查询部门下拉树结构 */
		getDeptTree() {
			deptList().then((response) => {
				this.deptOptions = response.data;
				// this.enabledDeptOptions = this.filterDisabledDept(
				// 	JSON.parse(JSON.stringify(response.data))
				// );
			});
		},
    filterDept(query) {
      if (!query) {
        this.filteredCities = [...this.options4dept];
        return;
      }
      const q = query.toLowerCase();
      this.filteredCities = this.options4dept.filter(city => 
        city.deptName.includes(q) || 
        city.deptName.toLowerCase().includes(q) || 
        city.deptName.includes(q)
      );
    },
    /** 查询公安武警列表 */
    getList() {
      this.loading = true;
      listPsap(this.queryParams).then((response) => {
        this.psapList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        createBy: null,
        createTime: null,
        orderNum: null,
        deptIds: [],
        type: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加公安武警";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getPsap(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改公安武警";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updatePsap(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPsap(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除公安武警编号为"' + ids + '"的数据项？')
        .then(function () {
          return delPsap(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "gaoqu/psap/export",
        {
          ...this.queryParams,
        },
        `psap_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
  